diff --git a/src/os/unix/ngx_process_cycle.c b/src/os/unix/ngx_process_cycle.c
index 92f6bf6..af3234d 100644
--- a/src/os/unix/ngx_process_cycle.c
+++ b/src/os/unix/ngx_process_cycle.c
@@ -862,26 +862,14 @@ ngx_worker_process_init(ngx_cycle_t *cycle, ngx_uint_t priority)
     }
 #endif
 
-    if (geteuid() == 0) {
-        if (setgid(ccf->group) == -1) {
-            ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
-                          "setgid(%d) failed", ccf->group);
-            /* fatal */
-            exit(2);
-        }
-
-        if (initgroups(ccf->username, ccf->group) == -1) {
-            ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
-                          "initgroups(%s, %d) failed",
-                          ccf->username, ccf->group);
-        }
+#ifdef NGX_HAVE_CAPABILITIES
+    if (ccf->use_bind_capability && ngx_clear_capability(cycle->log) != NGX_OK) {
+	exit(2);
+    }
+#endif
 
-        if (setuid(ccf->user) == -1) {
-            ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
-                          "setuid(%d) failed", ccf->user);
-            /* fatal */
-            exit(2);
-        }
+    if (ngx_switch_user(cycle) == NGX_ERROR) {
+	exit(2);
     }
 
 #if (NGX_HAVE_SCHED_SETAFFINITY)
diff --git a/src/os/unix/ngx_time.c b/src/os/unix/ngx_time.c
index 4ca8be6..6493906 100644
--- a/src/os/unix/ngx_time.c
+++ b/src/os/unix/ngx_time.c
@@ -101,3 +101,68 @@ ngx_libc_gmtime(time_t s, struct tm *tm)
 
 #endif
 }
+
+#if (NGX_CLOCK)
+ngx_timespec_t
+ngx_timespec_diff(ngx_timespec_t *start, ngx_timespec_t *end)
+{
+    ngx_timespec_t temp;
+    if ((end->tv_nsec - start->tv_nsec) < 0) {
+	temp.tv_sec = end->tv_sec - start->tv_sec-1;
+	temp.tv_nsec = 1000000000 + end->tv_nsec - start->tv_nsec;
+    } else {
+	temp.tv_sec = end->tv_sec - start->tv_sec;
+	temp.tv_nsec = end->tv_nsec - start->tv_nsec;
+    }
+    return temp;
+}
+
+ngx_int_t
+ngx_clock_gettime(ngx_clockid_t id, ngx_timespec_t *res)
+{
+    return (ngx_int_t)clock_gettime((clockid_t)id, (struct timespec*)res);
+}
+
+#if (NGX_HAVE_CLOCK_PROFILE)
+ngx_timeval_t       ngx_gettimeofday_start_tv = {0, 0};
+
+static void
+ngx_gettimeofday_init()
+{
+    ngx_timespec_t      ts;
+    ngx_timeval_t       tv;
+
+    gettimeofday(&tv, NULL);
+    ngx_clock_gettime(NGX_CLOCK_PROFILE, &ts);
+
+    if ((tv.tv_usec - ts.tv_nsec/1000) < 0) {
+        ngx_gettimeofday_start_tv.tv_sec = tv.tv_sec - 1;
+        ngx_gettimeofday_start_tv.tv_usec = 1000000 + tv.tv_usec - ts.tv_nsec/1000;
+    } else {
+        ngx_gettimeofday_start_tv.tv_sec = tv.tv_sec;
+        ngx_gettimeofday_start_tv.tv_usec = tv.tv_usec - ts.tv_nsec/1000;
+    }
+}
+
+void ngx_gettimeofday(ngx_timeval_t *tp)
+{
+    ngx_timespec_t      ts;
+
+    if (ngx_gettimeofday_start_tv.tv_sec == 0 &&
+        ngx_gettimeofday_start_tv.tv_usec == 0) {
+	ngx_gettimeofday_init();
+    }
+
+    ngx_clock_gettime(NGX_CLOCK_PROFILE, &ts);
+
+    if ((ts.tv_nsec/1000 + ngx_gettimeofday_start_tv.tv_usec) > 1000000) {
+        tp->tv_sec = ngx_gettimeofday_start_tv.tv_sec + 1;
+        tp->tv_sec = ngx_gettimeofday_start_tv.tv_usec + ts.tv_nsec/1000 - 1000000;
+    } else {
+        tp->tv_sec = ngx_gettimeofday_start_tv.tv_sec;
+        tp->tv_usec = ngx_gettimeofday_start_tv.tv_usec + ts.tv_nsec/1000;
+    }
+}
+#endif
+
+#endif
diff --git a/src/os/unix/ngx_time.h b/src/os/unix/ngx_time.h
index 5d9406c..6a74768 100644
--- a/src/os/unix/ngx_time.h
+++ b/src/os/unix/ngx_time.h
@@ -16,6 +16,7 @@ typedef ngx_rbtree_key_t      ngx_msec_t;
 typedef ngx_rbtree_key_int_t  ngx_msec_int_t;
 
 typedef struct tm             ngx_tm_t;
+typedef struct timeval        ngx_timeval_t;
 
 #define ngx_tm_sec            tm_sec
 #define ngx_tm_min            tm_min
@@ -57,7 +58,57 @@ void ngx_localtime(time_t s, ngx_tm_t *tm);
 void ngx_libc_localtime(time_t s, struct tm *tm);
 void ngx_libc_gmtime(time_t s, struct tm *tm);
 
+
+#if (NGX_CLOCK)
+
+typedef struct timespec ngx_timespec_t;
+typedef clockid_t       ngx_clockid_t;
+
+#if (NGX_HAVE_CLOCK_REALTIME)
+#define NGX_CLOCK_REALTIME           CLOCK_REALTIME
+#endif	/* NGX_HAVE_CLOCK_REALTIME */
+
+#if (NGX_HAVE_CLOCK_VIRTUAL)
+#define NGX_CLOCK_VIRTUAL            CLOCK_VIRTUAL
+#endif	/* NGX_HAVE_CLOCK_VIRTUAL */
+
+#if (NGX_HAVE_CLOCK_MONOTONIC)
+#define NGX_CLOCK_MONOTONIC          CLOCK_MONOTONIC
+#endif	/* NGX_HAVE_CLOCK_MONOTONIC */
+
+#if (NGX_HAVE_CLOCK_PROCESS_CPUTIME_ID)
+#define NGX_CLOCK_PROCESS_CPUTIME_ID CLOCK_PROCESS_CPUTIME_ID
+#endif	/* NGX_HAVE_CLOCK_PROCESS_CPUTIME_ID */
+
+#if (NGX_HAVE_CLOCK_THREAD_CPUTIME_ID)
+#define NGX_CLOCK_THREAD_CPUTIME_ID  CLOCK_THREAD_CPUTIME_ID
+#endif	/* NGX_HAVE_CLOCK_THREAD_CPUTIME_ID */
+
+#if (NGX_HAVE_CLOCK_PROFILE)
+#define NGX_CLOCK_PROFILE            CLOCK_PROFILE
+#endif	/* NGX_HAVE_CLOCK_PROFILE */
+
+#if (NGX_HAVE_CLOCK_PROF)
+#define NGX_CLOCK_PROFILE            CLOCK_PROF
+#endif	/* NGX_HAVE_CLOCK_PROF */
+
+#if (NGX_HAVE_CLOCK_UPTIME)
+#define NGX_CLOCK_UPTIME            CLOCK_UPTIME
+#endif	/* NGX_HAVE_CLOCK_PROF */
+
+ngx_timespec_t ngx_timespec_diff(ngx_timespec_t *start, ngx_timespec_t *end);
+ngx_int_t ngx_clock_gettime(ngx_clockid_t id, ngx_timespec_t *res);
+
+#endif /* NGX_CLOCK */
+
+#if (NGX_CLOCK) && (NGX_HAVE_CLOCK_PROFILE)
+extern ngx_timespec_t      ngx_gettimeofday_start_ts;
+
+void ngx_gettimeofday(ngx_timeval_t *tp);
+#else
 #define ngx_gettimeofday(tp)  (void) gettimeofday(tp, NULL);
+#endif	/* (NGX_CLOCK) && (NGX_HAVE_CLOCK_MONOTONIC) */
+
 #define ngx_msleep(ms)        (void) usleep(ms * 1000)
 #define ngx_sleep(s)          (void) sleep(s)
 
diff --git a/src/os/unix/ngx_user.c b/src/os/unix/ngx_user.c
index 4bad1c3..e866c6c 100644
--- a/src/os/unix/ngx_user.c
+++ b/src/os/unix/ngx_user.c
@@ -7,6 +7,10 @@
 #include <ngx_config.h>
 #include <ngx_core.h>
 
+#if (NGX_HAVE_CAPABILITIES)
+#include <sys/prctl.h>
+#endif
+
 
 /*
  * Solaris has thread-safe crypt()
@@ -106,3 +110,132 @@ ngx_crypt(ngx_pool_t *pool, u_char *key, u_char *salt, u_char **encrypted)
 #endif
 
 #endif /* NGX_CRYPT */
+
+ngx_int_t ngx_switch_user(ngx_cycle_t *cycle)
+{
+    ngx_core_conf_t  *ccf;
+
+    ccf = (ngx_core_conf_t *) ngx_get_conf(cycle->conf_ctx, ngx_core_module);
+
+    if (geteuid()) {
+        return NGX_DONE;
+    }
+
+    if (setgid(ccf->group) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
+                      "setgid(%d) failed", ccf->group);
+        return NGX_ERROR;
+    }
+
+    if (initgroups(ccf->username, ccf->group) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
+                      "initgroups(%s, %d) failed",
+                      ccf->username, ccf->group);
+        return NGX_ERROR;
+    }
+
+    if (setuid(ccf->user) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, cycle->log, ngx_errno,
+                      "setuid(%d) failed", ccf->user);
+        return NGX_ERROR;
+    }
+
+    return NGX_OK;
+}
+
+#if (NGX_HAVE_CAPABILITIES)
+
+ngx_int_t ngx_capabilities_prepare(ngx_log_t *log)
+{
+    if (geteuid()) {
+        return NGX_DONE;
+    }
+
+    if (prctl(PR_SET_KEEPCAPS, 1, 0, 0, 0) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "prctl(PR_SET_KEEPCAPS, 1) failed");
+        return NGX_ERROR;
+    }
+
+    return NGX_OK;
+}
+
+
+ngx_int_t ngx_set_capability(ngx_log_t *log, ngx_int_t ncap, cap_value_t *cap_list)
+{
+    cap_t  caps;
+
+    caps = cap_get_proc();
+    if (caps == NULL) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_get_proc() failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_set_flag(caps, CAP_EFFECTIVE, ncap, cap_list, CAP_SET) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_set_flag(CAP_EFFECTIVE) failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_set_flag(caps, CAP_PERMITTED, ncap, cap_list, CAP_SET) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_set_flag(CAP_PERMITTED) failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_set_flag(caps, CAP_INHERITABLE, ncap, cap_list, CAP_SET) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_set_flag(CAP_INHERITABLE) failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_set_proc(caps) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_set_proc() failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_free(caps) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_free() failed");
+        return NGX_ERROR;
+    }
+
+    return NGX_OK;
+}
+
+
+ngx_int_t ngx_clear_capability(ngx_log_t *log)
+{
+    cap_t      caps;
+
+    caps = cap_get_proc();
+    if (caps == NULL) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_get_proc() failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_clear(caps) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_clear() failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_set_proc(caps) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_set_proc() failed");
+        return NGX_ERROR;
+    }
+
+    if (cap_free(caps) == -1) {
+        ngx_log_error(NGX_LOG_EMERG, log, ngx_errno,
+                      "cap_free() failed");
+        return NGX_ERROR;
+    }
+
+    return NGX_OK;
+}
+
+#endif
diff --git a/src/os/unix/ngx_user.h b/src/os/unix/ngx_user.h
index a24a66b..3fea196 100644
--- a/src/os/unix/ngx_user.h
+++ b/src/os/unix/ngx_user.h
@@ -11,14 +11,36 @@
 #include <ngx_config.h>
 #include <ngx_core.h>
 
+#if (NGX_HAVE_CAPABILITIES)
+#include <sys/capability.h>
+#endif
+
 
 typedef uid_t  ngx_uid_t;
 typedef gid_t  ngx_gid_t;
 
+#if (NGX_CRYPT)
+
+#if (NGX_HAVE_GNU_CRYPT_R)
+
 
 ngx_int_t ngx_crypt(ngx_pool_t *pool, u_char *key, u_char *salt,
     u_char **encrypted);
 
+#endif
+
+#endif /* NGX_CRYPT */
+
+ngx_int_t ngx_switch_user(ngx_cycle_t *cycle);
+
+#if (NGX_HAVE_CAPABILITIES)
+
+ngx_int_t ngx_capabilities_prepare(ngx_log_t *log);
+
+ngx_int_t ngx_set_capability(ngx_log_t *log, ngx_int_t ncap, cap_value_t *cap_list);
+
+ngx_int_t ngx_clear_capability(ngx_log_t *log);
 
+#endif
 
 #endif /* _NGX_USER_H_INCLUDED_ */
diff --git a/version.sh b/version.sh
new file mode 100755
index 0000000..9fa18bc
--- /dev/null
+++ b/version.sh
@@ -0,0 +1,21 @@
+#!/bin/bash
+test -d .git || exit 0
+git rev-list HEAD | sort > config.git-hash
+LOCALVER=`wc -l config.git-hash | awk '{print $1}'`
+if [ $LOCALVER \> 1 ] ; then
+    VER=`git rev-list origin/master | sort | join config.git-hash - | wc -l | awk '{print $1}'`
+    if [ $VER != $LOCALVER ] ; then
+        VER="$VER+$(($LOCALVER-$VER))"
+    elif git status | grep -q "modified:" ; then
+        VER="${VER}M"
+    fi
+    VER="$VER.$(git rev-list HEAD -n 1 | head -c 7)"
+else
+    VER="x"
+fi
+rm -f config.git-hash
+sed -i -e "s:\"\([0-9]*\.[0-9]*\.[0-9]*\).*\".*$:\"\1\.$VER\":g" \
+    -e "s:\"nginx/\":\"nginx-catap/\":g" \
+    src/core/nginx.h
+sed -i -e "s:'\([0-9]*\.[0-9]*\.[0-9]*\).*'.*$:\'\1\.$VER\':g" \
+    src/http/modules/perl/nginx.pm
